


; Reads register A and returns a number in register B that has that bit set. 
; Eg: A = 4, returns B = 0b1000
; Eg: A = 6, returns B = 0b100000
; If A > 16, B = -1 is retured 
:set_bit
    IFG A, 16
        SET B, -1 
    IFG A, 16 
        SET PC, set_bit_end 
    
    SET B, 1
    SHL B, A
    :set_bit_end 
    SET PC, POP

; Returns the rightmost bit in register A and returns it in register B. 
; Eg: A = 0xc => B = 2 
; If there is no ones in A, -1 will be returned. 
:get_rightmost_bit 
    IFG A, 0 
        SET B, -1 
    IFG A, 0 
        SET PC, get_rightmost_bit_end 
    
    SET B, -1 
    
    :get_rightmost_bit_end
    SET PC, POP


; Clears an area in the memory. Takes the start position in the A register and 
; the number of elements that should be cleared in the B register. 
:clear_mem 
    IFE B, 0 
        SET PC, POP 
    SET [A], 0 
    ADD A, 1
    SUB B, 1 
    SET PC, clear_mem 
    
    
    